package com.androdome.commander;

import java.util.*;

import com.androdome.perms.*;
import com.cliffblaster.game.Command;
import com.cliffblaster.game.api.JavaPlugin;
import com.cliffblaster.game.api.RegisteredEvent;
import com.cliffblaster.game.api.abstraction.Server;
import com.cliffblaster.game.api.event.Event.Priority;
import com.cliffblaster.game.api.event.Event.Type;
import com.cliffblaster.game.api.event.PlayerDisconnectEvent;
import com.cliffblaster.game.api.event.PlayerEventListener;
import com.cliffblaster.game.net.ServerHandler;

public class MoreCommands extends JavaPlugin
{
    HashMap<ServerHandler, RegisteredEvent> eventHolder;
    Permissions perms;
    HashMap<ServerHandler, byte[]> undoBuffer = new HashMap<ServerHandler, byte[]>();
    
    public MoreCommands() {
        this.eventHolder = new HashMap<ServerHandler, RegisteredEvent>();
    }
    
    public void init() {
        if (this.getManager().getPlugin("Permissions") != null) {
            this.perms = (Permissions)this.getManager().getPlugin("Permissions");
            Command c = new CuboidCommand(this);
            this.registerCommand("cuboid", c, true);
            this.registerCommand("z", c, false);
            c = new ReplaceCommand(this);
            this.registerCommand("replace", c, true);
            this.registerCommand("r", c, false);
            this.registerCommand("undo", new UndoCommand(this), true);
            Server.log.info("MoreCommands plugin loaded!");
            
            this.registerEvents();
            
            return;
        }
        Server.log.warning("You need a permissions plugin to use MoreCommands");
        this.getManager().unload((JavaPlugin)this);
    }
    
    private void registerEvents() {
		this.registerEvent(Type.PLAYER_DISCONNECT, new PlayerEventListener()
		{
			public void onPlayerDisconnected(PlayerDisconnectEvent playerDisconnectEvent)
			{
				ServerHandler playerHandler = playerDisconnectEvent.getHandler();
				RegisteredEvent evt = eventHolder.remove(playerHandler);
				undoBuffer.remove(playerHandler);
				if(evt != null)
				{
					Server.log.warning("Unregistering dangling event");
					MoreCommands.this.unregisterEvent(evt);
				}
			}
		}, Priority.NORMAL);
	}

	public void destroy() {
		Server.log.info("MoreCommands plugin destroyed!");
    }
}
