package com.androdome.perms;

import com.cliffblaster.game.api.JavaPlugin;
import com.cliffblaster.game.api.abstraction.Server;
import com.cliffblaster.game.api.event.Event.Priority;
import com.cliffblaster.game.api.event.Event.Type;
import com.cliffblaster.game.api.event.PermissionEventListener;
import com.cliffblaster.game.api.event.PermissionRequestEvent;
import com.cliffblaster.game.net.ServerHandler;

public class Permissions extends JavaPlugin
{
    private PermissionsManager manager;
    
    public Permissions() {
    }
    
    public void init() {
        this.manager = new PermissionsManager(this);
        this.registerEvent(Type.PERMISSION_REQUEST, new PermissionEventListener(){
        	@Override
        	public void onPermissionRequest(PermissionRequestEvent askEvent){
        		askEvent.setPermission(hasPermission(askEvent.commander, askEvent.permission));
        	}
        }, Priority.REALTIME);
        Server.log.info("Permissions plugin loaded!");
    }

    
    public boolean hasPermission(final ServerHandler player, final String permission) {
        return this.manager.hasPermissions(permission, player);
    }
    
    public String getFirstMatchingPermission(final ServerHandler player, final String permission) {
        return this.manager.getFirstMatchingPermission(permission, player);
    }
    
    public void destroy() {
        Server.log.info("Permissions plugin destroyed!");
    }
}
