package com.androdome.polyterra;

import com.cliffblaster.game.ChatColor;
import com.cliffblaster.game.Command;
import com.cliffblaster.game.api.abstraction.Server;
import com.cliffblaster.game.api.event.PermissionRequestEvent;
import com.cliffblaster.game.net.ServerHandler;
import com.cliffblaster.game.net.packet.Packet9Chat;

public class ReturnCommand extends Command
{

	final MainPlugin plugin;

	public ReturnCommand(MainPlugin plugin) {
		this.plugin = plugin;
	}

	@Override
	public boolean hasPermission(String[] command, ServerHandler caller) {
		PermissionRequestEvent event = requestPermission(caller, "polyterra.standard.return");
		if (event.wasHandled())
		{
			return event.hasPermission();
		}
		return true;
	}

	@Override
	public boolean execute(String[] args, final ServerHandler caller) {
		final LevelData data = plugin.getDataFromLevel(caller.getLevel());
		if (caller.getLevel().equals(getServer().getLevel()))
		{
			sendMessage(caller, "You are already in the server hub!", ChatColor.RED);
			return true;
		}
		else if (data != null)
		{
			data.connectedPlayers.remove(caller);
		}
		sendMessage(caller, "Joining...", ChatColor.GREEN);
		new Thread() {
			public void run() {
				Server.broadcast(new Packet9Chat((caller.getFullPlayerName().startsWith("&") ? "" : ChatColor.PURPLE) + caller.getFullPlayerName() + " " + ChatColor.PURPLE + "went to another level!"), caller, caller.getLevel());
				caller.setLevel(getServer().getLevel(), "Joining server hub...", Server.getDesc());
				Server.broadcast(new Packet9Chat((caller.getFullPlayerName().startsWith("&") ? "" : ChatColor.PURPLE) + caller.getFullPlayerName() + " " + ChatColor.PURPLE + "has joined the level!"), null, caller.getLevel());
				sendMessage(caller, "Joined!", ChatColor.GREEN);
				if (data != null && data.levelCanCompress && data.connectedPlayers.size() == 0)
				{
					try
					{
						data.compress();
					}
					catch (InterruptedException e)
					{
						e.printStackTrace();
					}
				}
			}
		}.start();
		return true;
	}

	@Override
	public String getHelpDesc() {
		return "Joins a loaded level";
	}

	@Override
	public void printUsage(String[] arguments, ServerHandler caller) {
		sendMessage(caller, "/" + arguments[0] + " <name>", ChatColor.CYAN);
	}

	void sendMessagePublic(ServerHandler caller, String message, ChatColor color) {
		this.sendMessage(caller, message, color);
	}
}