package com.androdome.polyterra;

import com.cliffblaster.game.ChatColor;
import com.cliffblaster.game.Command;
import com.cliffblaster.game.api.event.PermissionRequestEvent;
import com.cliffblaster.game.net.ServerHandler;

public class UnloadCommand extends Command
{

	final MainPlugin plugin;

	public UnloadCommand(MainPlugin plugin) {
		this.plugin = plugin;
	}

	@Override
	public boolean hasPermission(String[] command, ServerHandler caller) {
		PermissionRequestEvent event;
		if(command.length > 1)
			event = requestPermission(caller, "polyterra.level.unload."+command[1].trim().toLowerCase());
		else event = requestPermission(caller, "polyterra.level.unload");
		if(event.wasHandled())
		{
			return event.hasPermission();
		}
		return caller == null || caller.isAdmin;
	}


	@Override
	public boolean execute(String[] args, ServerHandler caller) {
		if(args.length > 1)
		{
			String levelToLoad = args[1];
			if(plugin.unloadLevel(levelToLoad))
				sendMessage(caller, "Unloaded!", ChatColor.LIME);
			else
				sendMessage(caller, "Failed to unload or level not loaded", ChatColor.RED);
			return true;
		}
		return false;
	}

	@Override
	public String getHelpDesc() {
		return "Unloads a loaded level";
	}

	@Override
	public void printUsage(String[] arguments, ServerHandler caller) {
		sendMessage(caller, "/" + arguments[0] + " <name>", ChatColor.CYAN);
	}

	void sendMessagePublic(ServerHandler caller, String message, ChatColor color) {
		this.sendMessage(caller, message, color);
	}
}